diff -u main.c main.c
--- main.c	(working copy)
+++ main.c	(working copy)
@@ -692,6 +692,7 @@
   int query_only=0;
   int batch=0,i;
   int run_cache_test=0;
+  int last_audio_track;
 
   char *logfile_name=NULL;
   char *reportfile_name=NULL;
@@ -1185,9 +1186,19 @@
       
     }
 
+	last_audio_track = d->tracks;
 	if (toc_offset && !force_overread) {
-		d->disc_toc[d->tracks].dwStartSector -= toc_offset;
-		if (last_sector > cdda_track_lastsector(d, d->tracks))
+		int lt;
+
+		for (lt = d->tracks ; lt > 0 ; lt--)
+			if (cdda_track_audiop(d, lt))
+				break;
+
+		if (lt > 0)
+			last_audio_track = lt;
+
+		d->disc_toc[last_audio_track].dwStartSector -= toc_offset;
+		if (last_sector > cdda_track_lastsector(d, last_audio_track))
 			last_sector -= toc_offset;
     }
 
@@ -1337,7 +1348,7 @@
 	}
 
 	sectorlen = batch_last - batch_first + 1;
-	if (cdda_sector_gettrack(d, cursor) == d->tracks &&
+	if (cdda_sector_gettrack(d, cursor) == last_audio_track &&
 		toc_offset > 0 && !force_overread)
 	{
 		sectorlen += toc_offset;
@@ -1422,11 +1433,11 @@
 
 	  /* One last bit of silliness to deal with sample offsets */
 	  if(sample_offset && cursor>batch_last){
-		if (cdda_sector_gettrack(d, batch_last) < d->tracks || force_overread) {
+		if (cdda_sector_gettrack(d, batch_last) < last_audio_track || force_overread) {
 		    int i;
 
 			/* Need to flush the buffer when overreading into the leadout */
-			if (cdda_sector_gettrack(d, batch_last) == d->tracks)
+			if (cdda_sector_gettrack(d, batch_last) == last_audio_track)
 				paranoia_seek(p, cursor, SEEK_SET);
 
 		    /* read a sector and output the partial offset.  Save the
@@ -1472,7 +1483,7 @@
 
 	/* Write sectors of silent audio to compensate for
        missing samples that would be in the leadout */
-	if (cdda_sector_gettrack(d, batch_last) == d->tracks &&
+	if (cdda_sector_gettrack(d, batch_last) == last_audio_track &&
 		toc_offset > 0 && !force_overread)
 	{
 		char *silence;